start test2

//
// WARNING WARNING WARNING
//
// This is an example only.
// It is NOT a secure encryption
// although is can easily be
// made so.
//
// 1. It needs more stages
//    of the mix (and unmix) routines
//
// 2. It needs a key schedule
//    with:
//          a) mixes the key into
//             a "mixed-up key"
//             so that no single part of
//             the key may be separately
//             tested.
//
//          b) Blends the key into the
//             "layer-cake" of rounds
//             of mix() at SEVERAL (more than 4)
//             layer points. By blending is meant
//             xor-ing only 32-bits of the key with
//             one of the 3 (a,b,or c) longs of the
//             data at that point of the mix. It is
//             important to only xor only 32-bits of
//             the key at each key-mixing layer.
//             Between key-mixing layers, there can
//             be a large number of regular mixing
//             layers.
//
// 3. It needs more rounds ( at least 40 calls to mix )
//    per every 12 bytes of data.
//
// 4. It needs a feedback (called Cipher-Feedback-Mode)
//    which every 12-byte chunk of output is dependent
//    on the previous encryption data (and thus key)
//    in order to thwart finding specific outputs for
//    known keys.
//
// At that point it can be reasonably secure.
// A renowned cryptanalyst said he could not find any
// attacks of less than 2^64 complexity. Of course, this
// is conditional based on all of the other details.
// But it is a guide to developing a reasonable cipher.
//
char infilename[128];
char outfilename[128];
char enorde[32];
long inbuf[4];
long outbuf[4];
long initval = 0x6e89c42e;
long gbla;
long gblb;
long gblc;
long inva;
long invb;
long invc;
long o_creat = 0x0101;
long neg = 0xffffffff;


main
{
reg long infd;
reg long outfd;
reg long rlen;
reg long i;
reg long dtype;
reg long negl;

negl = neg;

dialog("encrypt(e) or decrypt(d)?","e",enorde);
dtype = enorde[0];
//
// open input file
//
dialog("enter input filename","",infilename);
printf("infile=%s\n",infilename);

set infd = open( infilename, 0 );
if ( infd == negl )
{
  printf("couldn't open input file %s\n",infilename);
  exit(1);
}
//
// open output file
//
dialog("enter output filename","",outfilename);
printf("outfile=%s\n",outfilename);

set outfd = open( outfilename, o_creat );
if ( outfd == negl )
{
  printf("couldn't open output file %s\n",outfilename);
  exit(1);
}

for (i=0; i < 0x4000 ;i++)
{
// pad before read
  inbuf[0] = initval;
  inbuf[1] = initval;
  inbuf[2] = initval;

  set rlen = read(infd,inbuf,12);
  if ( rlen == 0 )
  {
     break;
  }
  if ( dtype == 0x65 )
  {
    encrypt( inbuf, outbuf );
  }
  if ( dtype == 0x64 )
  {
    decrypt( inbuf, outbuf );
  }

  set rlen = write(outfd,outbuf,12);
  if ( rlen != 12 )
  {
     printf("write error\n");
     exit(1);
  }
}

close( infd );
close( outfd );

printf("done\n");
}

//  r0 - input block ptr
//  r1 - output block ptr
//
//  encrypt a 4-longword block
//
//
subroutine  encrypt
{
reg long *inp;
reg long *outp;
inp = r0;
outp = r1;
mix( inp[0], inp[1], inp[2] );
mix( gblb, gbla, gblc );
mix( gbla, gblb, gblc );
outp[0] = gbla;
outp[1] = gblb;
outp[2] = gblc;
}

//
subroutine  decrypt
{
reg long *inp;
reg long *outp;
inp = r0;
outp = r1;
unmix( inp[0], inp[1], inp[2] );
unmix( inva, invb, invc );
unmix( invb, inva, invc );
outp[0] = inva;
outp[1] = invb;
outp[2] = invc;
}

//
// the basic mix hash from bob jenkins
// modified to use rotates instead of shifts
// note that each operation is a
// mulipermutation (invertible)
// which preserves statistics
// in the sense that any ouput
// value can be generated in
// k=2^n ways out of k*k inputs,
// so each output value is equally
// likely.
// mix( a, b, c )
//

subroutine mix
{
  reg long a;
  reg long b;
  reg long c;
  reg long t;
  a = r0;
  b = r1;
  c = r2;

  a -= b;
  a -= c;
  t = c;
  t >>> 13;
  a ^= t;
  b -= c;
  b -= a;
  t = a;
  t <<< 8;
  b ^= t;
  c -= a;
  c -= b;
  t = b;
  t >>> 13
  c ^= t;
  a -= b;
  a -= c;
  t = c;
  t >>> 12;
  a ^= t;
  b -= c;
  b -= a;
  t = a;
  t <<< 16
  b ^= t;
  c -= a;
  c -= b;
  t = b;
  t >>> 5;
  c ^= t;
  a -= b;
  a -= c;
  t = c;
  t >>> 3;
  a ^= t;
  b -= c;
  b -= a;
  t = a;
  t <<< 10;
  b ^= t;
  c -= a;
  c -= b;
  t = b;
  t >>> 15;
  c ^= t;

  gbla = a;
  gblb = b;
  gblc = c;
}

//
// unmix( a, b, c )
//
subroutine unmix
{
  reg long a;
  reg long b;
  reg long c;
  reg long t;

  a = r0;
  b = r1;
  c = r2;

  t = b;
  t >>> 15;
  c ^= t;
  c += b;
  c += a;
  t = a;
  t <<< 10;
  b ^= t;
  b += a;
  b += c;
  t = c;
  t >>> 3;
  a ^= t;
  a += c;
  a += b;
  t = b;
  t >>> 5
  c ^= t;
  c += b;
  c += a;
  t = a;
  t <<< 16;
  b ^= t;
  b += a;
  b += c;
  t = c;
  t >>> 12;
  a ^= t;
  a += c;
  a += b;
  t = b;
  t >>> 13;
  c ^= t
  c += b;
  c += a;
  t = a;
  t <<< 8;
  b ^= t;
  b += a;
  b += c;
  t = c;
  t >>> 13;
  a ^= t;
  a += c;
  a += b;

  inva = a;
  invb = b;
  invc = c;
}
end
